commit 78155e7adf6010e81b9d6a0b1fe2b1ccaeadbc2b
Author: Varun Nagaraju <varun.nagaraju@percona.com>
Date:   Wed May 15 18:32:29 2024 +0530

    PS-9174 Incorrect results when using group by loose index scan
    
    https://perconadev.atlassian.net/browse/PS-9174
    
    Bug#35854362 mysql/mysql-server@c7e824d18f7
    
    Description:
    - Indexes are ordered based on their keys. Loose
      index scan effectively jumps from one unique value
      (or set of values) to the next based on the index’s prefix
      keys.
    
    - To “jump” values in an index, we use the handler
      call: ha_index_read_map().
    
    - the first range read sets an end-of-range
      value to indicate the end of the first range.
    
    - The next range read does not clear the previous end-of-range value
      and applies it to the current range.
    
    - Since the end-of-range value has already been crossed in the
      previous range read, this causes the reads to stop. So the
      iteration is finished with the current range without moving
      onto the next range(unique set of values)resulting in an
      incorrect query result.
    
    Fix:
    - In order to find the next unique value, the old end-of-range
      value is cleared.
    
    Change-Id: I84290fb794db13ec6f0795dd14a92cf85b9dad09

diff --git a/mysql-test/r/select_distinct_debug.result b/mysql-test/r/select_distinct_debug.result
new file mode 100644
index 00000000000..eccf82b9bf7
--- /dev/null
+++ b/mysql-test/r/select_distinct_debug.result
@@ -0,0 +1,74 @@
+#
+# Bug #35854362: INCORRECT RESULTS WHEN USING GROUP BY LOOSE
+#                INDEX SCAN
+#
+CREATE TABLE t1 (
+a1 CHAR(64),
+a2 CHAR(64),
+b CHAR(16),
+c CHAR(16) NOT NULL,
+d CHAR(16),
+dummy CHAR(248) DEFAULT ' '
+  );
+INSERT INTO t1 (a1, a2, b, c, d) VALUES
+('a','a','a','a111','xy1'),('a','a','a','b111','xy2'),('a','a','a','c111','xy3'),('a','a','a','d111','xy4'),
+('a','a','b','e112','xy1'),('a','a','b','f112','xy2'),('a','a','b','g112','xy3'),('a','a','b','h112','xy4'),
+('a','b','a','i121','xy1'),('a','b','a','j121','xy2'),('a','b','a','k121','xy3'),('a','b','a','l121','xy4'),
+('a','b','b','m122','xy1'),('a','b','b','n122','xy2'),('a','b','b','o122','xy3'),('a','b','b','p122','xy4'),
+('b','a','a','a211','xy1'),('b','a','a','b211','xy2'),('b','a','a','c211','xy3'),('b','a','a','d211','xy4'),
+('b','a','b','e212','xy1'),('b','a','b','f212','xy2'),('b','a','b','g212','xy3'),('b','a','b','h212','xy4'),
+('b','b','a','i221','xy1'),('b','b','a','j221','xy2'),('b','b','a','k221','xy3'),('b','b','a','l221','xy4'),
+('b','b','b','m222','xy1'),('b','b','b','n222','xy2'),('b','b','b','o222','xy3'),('b','b','b','p222','xy4'),
+('c','a','a','a311','xy1'),('c','a','a','b311','xy2'),('c','a','a','c311','xy3'),('c','a','a','d311','xy4'),
+('c','a','b','e312','xy1'),('c','a','b','f312','xy2'),('c','a','b','g312','xy3'),('c','a','b','h312','xy4'),
+('c','b','a','i321','xy1'),('c','b','a','j321','xy2'),('c','b','a','k321','xy3'),('c','b','a','l321','xy4'),
+('c','b','b','m322','xy1'),('c','b','b','n322','xy2'),('c','b','b','o322','xy3'),('c','b','b','p322','xy4'),
+('d','a','a','a411','xy1'),('d','a','a','b411','xy2'),('d','a','a','c411','xy3'),('d','a','a','d411','xy4'),
+('d','a','b','e412','xy1'),('d','a','b','f412','xy2'),('d','a','b','g412','xy3'),('d','a','b','h412','xy4'),
+('d','b','a','i421','xy1'),('d','b','a','j421','xy2'),('d','b','a','k421','xy3'),('d','b','a','l421','xy4'),
+('d','b','b','m422','xy1'),('d','b','b','n422','xy2'),('d','b','b','o422','xy3'),('d','b','b','p422','xy4'),
+('a','a','a','a111','xy1'),('a','a','a','b111','xy2'),('a','a','a','c111','xy3'),('a','a','a','d111','xy4'),
+('a','a','b','e112','xy1'),('a','a','b','f112','xy2'),('a','a','b','g112','xy3'),('a','a','b','h112','xy4'),
+('a','b','a','i121','xy1'),('a','b','a','j121','xy2'),('a','b','a','k121','xy3'),('a','b','a','l121','xy4'),
+('a','b','b','m122','xy1'),('a','b','b','n122','xy2'),('a','b','b','o122','xy3'),('a','b','b','p122','xy4'),
+('b','a','a','a211','xy1'),('b','a','a','b211','xy2'),('b','a','a','c211','xy3'),('b','a','a','d211','xy4'),
+('b','a','b','e212','xy1'),('b','a','b','f212','xy2'),('b','a','b','g212','xy3'),('b','a','b','h212','xy4'),
+('b','b','a','i221','xy1'),('b','b','a','j221','xy2'),('b','b','a','k221','xy3'),('b','b','a','l221','xy4'),
+('b','b','b','m222','xy1'),('b','b','b','n222','xy2'),('b','b','b','o222','xy3'),('b','b','b','p222','xy4'),
+('c','a','a','a311','xy1'),('c','a','a','b311','xy2'),('c','a','a','c311','xy3'),('c','a','a','d311','xy4'),
+('c','a','b','e312','xy1'),('c','a','b','f312','xy2'),('c','a','b','g312','xy3'),('c','a','b','h312','xy4'),
+('c','b','a','i321','xy1'),('c','b','a','j321','xy2'),('c','b','a','k321','xy3'),('c','b','a','l321','xy4'),
+('c','b','b','m322','xy1'),('c','b','b','n322','xy2'),('c','b','b','o322','xy3'),('c','b','b','p322','xy4'),
+('d','a','a','a411','xy1'),('d','a','a','b411','xy2'),('d','a','a','c411','xy3'),('d','a','a','d411','xy4'),
+('d','a','b','e412','xy1'),('d','a','b','f412','xy2'),('d','a','b','g412','xy3'),('d','a','b','h412','xy4'),
+('d','b','a','i421','xy1'),('d','b','a','j421','xy2'),('d','b','a','k421','xy3'),('d','b','a','l421','xy4'),
+('d','b','b','m422','xy1'),('d','b','b','n422','xy2'),('d','b','b','o422','xy3'),('d','b','b','p422','xy4');
+CREATE INDEX idx_t1_0 ON t1 (a1);
+CREATE INDEX idx_t1_1 ON t1 (a1,a2,b,c);
+CREATE INDEX idx_t1_2 on t1 (a1,a2,b);
+CREATE PROCEDURE insert_multiple_rows(IN num_rows INT)
+BEGIN
+DECLARE counter INT DEFAULT 0;
+WHILE counter < num_rows DO
+INSERT INTO t1 (a1, a2, b, c, d, dummy)
+VALUES ('b', 'a', 'a', 'a211', 'xy1', '');
+SET counter = counter + 1;
+END WHILE;
+END $$
+CALL insert_multiple_rows(1000);
+SELECT @@innodb_purge_stop_now INTO @old_val;
+SET GLOBAL innodb_purge_stop_now = 1;
+DELETE FROM t1 WHERE a1 = 'b';
+SET SESSION DEBUG="+d,force_lis_for_group_by";
+SELECT DISTINCT a1
+FROM t1
+WHERE a1 IN ('a', 'd')
+AND a2 = 'b';
+a1
+a
+d
+SET SESSION DEBUG="-d,force_lis_for_group_by";
+SET GLOBAL innodb_purge_stop_now = @old_val;
+SET GLOBAL innodb_purge_run_now=1;
+DROP PROCEDURE insert_multiple_rows;
+DROP TABLE t1;
diff --git a/mysql-test/t/select_distinct_debug.test b/mysql-test/t/select_distinct_debug.test
new file mode 100644
index 00000000000..6a6a9c0cdad
--- /dev/null
+++ b/mysql-test/t/select_distinct_debug.test
@@ -0,0 +1,88 @@
+# for innodb_purge_stop_now=ON
+--source include/have_debug.inc
+
+--echo #
+--echo # Bug #35854362: INCORRECT RESULTS WHEN USING GROUP BY LOOSE
+--echo #                INDEX SCAN
+--echo #
+
+CREATE TABLE t1 (
+  a1 CHAR(64),
+  a2 CHAR(64),
+  b CHAR(16),
+  c CHAR(16) NOT NULL,
+  d CHAR(16),
+  dummy CHAR(248) DEFAULT ' '
+  );
+
+INSERT INTO t1 (a1, a2, b, c, d) VALUES
+('a','a','a','a111','xy1'),('a','a','a','b111','xy2'),('a','a','a','c111','xy3'),('a','a','a','d111','xy4'),
+('a','a','b','e112','xy1'),('a','a','b','f112','xy2'),('a','a','b','g112','xy3'),('a','a','b','h112','xy4'),
+('a','b','a','i121','xy1'),('a','b','a','j121','xy2'),('a','b','a','k121','xy3'),('a','b','a','l121','xy4'),
+('a','b','b','m122','xy1'),('a','b','b','n122','xy2'),('a','b','b','o122','xy3'),('a','b','b','p122','xy4'),
+('b','a','a','a211','xy1'),('b','a','a','b211','xy2'),('b','a','a','c211','xy3'),('b','a','a','d211','xy4'),
+('b','a','b','e212','xy1'),('b','a','b','f212','xy2'),('b','a','b','g212','xy3'),('b','a','b','h212','xy4'),
+('b','b','a','i221','xy1'),('b','b','a','j221','xy2'),('b','b','a','k221','xy3'),('b','b','a','l221','xy4'),
+('b','b','b','m222','xy1'),('b','b','b','n222','xy2'),('b','b','b','o222','xy3'),('b','b','b','p222','xy4'),
+('c','a','a','a311','xy1'),('c','a','a','b311','xy2'),('c','a','a','c311','xy3'),('c','a','a','d311','xy4'),
+('c','a','b','e312','xy1'),('c','a','b','f312','xy2'),('c','a','b','g312','xy3'),('c','a','b','h312','xy4'),
+('c','b','a','i321','xy1'),('c','b','a','j321','xy2'),('c','b','a','k321','xy3'),('c','b','a','l321','xy4'),
+('c','b','b','m322','xy1'),('c','b','b','n322','xy2'),('c','b','b','o322','xy3'),('c','b','b','p322','xy4'),
+('d','a','a','a411','xy1'),('d','a','a','b411','xy2'),('d','a','a','c411','xy3'),('d','a','a','d411','xy4'),
+('d','a','b','e412','xy1'),('d','a','b','f412','xy2'),('d','a','b','g412','xy3'),('d','a','b','h412','xy4'),
+('d','b','a','i421','xy1'),('d','b','a','j421','xy2'),('d','b','a','k421','xy3'),('d','b','a','l421','xy4'),
+('d','b','b','m422','xy1'),('d','b','b','n422','xy2'),('d','b','b','o422','xy3'),('d','b','b','p422','xy4'),
+('a','a','a','a111','xy1'),('a','a','a','b111','xy2'),('a','a','a','c111','xy3'),('a','a','a','d111','xy4'),
+('a','a','b','e112','xy1'),('a','a','b','f112','xy2'),('a','a','b','g112','xy3'),('a','a','b','h112','xy4'),
+('a','b','a','i121','xy1'),('a','b','a','j121','xy2'),('a','b','a','k121','xy3'),('a','b','a','l121','xy4'),
+('a','b','b','m122','xy1'),('a','b','b','n122','xy2'),('a','b','b','o122','xy3'),('a','b','b','p122','xy4'),
+('b','a','a','a211','xy1'),('b','a','a','b211','xy2'),('b','a','a','c211','xy3'),('b','a','a','d211','xy4'),
+('b','a','b','e212','xy1'),('b','a','b','f212','xy2'),('b','a','b','g212','xy3'),('b','a','b','h212','xy4'),
+('b','b','a','i221','xy1'),('b','b','a','j221','xy2'),('b','b','a','k221','xy3'),('b','b','a','l221','xy4'),
+('b','b','b','m222','xy1'),('b','b','b','n222','xy2'),('b','b','b','o222','xy3'),('b','b','b','p222','xy4'),
+('c','a','a','a311','xy1'),('c','a','a','b311','xy2'),('c','a','a','c311','xy3'),('c','a','a','d311','xy4'),
+('c','a','b','e312','xy1'),('c','a','b','f312','xy2'),('c','a','b','g312','xy3'),('c','a','b','h312','xy4'),
+('c','b','a','i321','xy1'),('c','b','a','j321','xy2'),('c','b','a','k321','xy3'),('c','b','a','l321','xy4'),
+('c','b','b','m322','xy1'),('c','b','b','n322','xy2'),('c','b','b','o322','xy3'),('c','b','b','p322','xy4'),
+('d','a','a','a411','xy1'),('d','a','a','b411','xy2'),('d','a','a','c411','xy3'),('d','a','a','d411','xy4'),
+('d','a','b','e412','xy1'),('d','a','b','f412','xy2'),('d','a','b','g412','xy3'),('d','a','b','h412','xy4'),
+('d','b','a','i421','xy1'),('d','b','a','j421','xy2'),('d','b','a','k421','xy3'),('d','b','a','l421','xy4'),
+('d','b','b','m422','xy1'),('d','b','b','n422','xy2'),('d','b','b','o422','xy3'),('d','b','b','p422','xy4');
+
+CREATE INDEX idx_t1_0 ON t1 (a1);
+CREATE INDEX idx_t1_1 ON t1 (a1,a2,b,c);
+CREATE INDEX idx_t1_2 on t1 (a1,a2,b);
+
+DELIMITER $$;
+
+CREATE PROCEDURE insert_multiple_rows(IN num_rows INT)
+BEGIN
+    DECLARE counter INT DEFAULT 0;
+    WHILE counter < num_rows DO
+        INSERT INTO t1 (a1, a2, b, c, d, dummy)
+        VALUES ('b', 'a', 'a', 'a211', 'xy1', '');
+        SET counter = counter + 1;
+    END WHILE;
+END $$
+
+DELIMITER ;$$
+
+CALL insert_multiple_rows(1000);
+
+SELECT @@innodb_purge_stop_now INTO @old_val;
+SET GLOBAL innodb_purge_stop_now = 1;
+
+DELETE FROM t1 WHERE a1 = 'b';
+
+SET SESSION DEBUG="+d,force_lis_for_group_by";
+SELECT DISTINCT a1
+FROM t1
+WHERE a1 IN ('a', 'd')
+    AND a2 = 'b';
+
+SET SESSION DEBUG="-d,force_lis_for_group_by";
+SET GLOBAL innodb_purge_stop_now = @old_val;
+SET GLOBAL innodb_purge_run_now=1;
+
+DROP PROCEDURE insert_multiple_rows;
+DROP TABLE t1;
diff --git a/sql/opt_range.cc b/sql/opt_range.cc
index 73ac761f8f3..d45775e136c 100644
--- a/sql/opt_range.cc
+++ b/sql/opt_range.cc
@@ -3075,6 +3075,7 @@ int test_quick_select(THD *thd, key_map keys_to_use,
     group_trp= get_best_group_min_max(&param, tree, &best_cost);
     if (group_trp)
     {
+      DBUG_EXECUTE_IF("force_lis_for_group_by", group_trp->cost_est.reset(););
       param.table->quick_condition_rows= min(group_trp->records,
                                              head->file->stats.records);
       Opt_trace_object grp_summary(trace,
@@ -11323,6 +11324,7 @@ int QUICK_RANGE_SELECT::get_next_prefix(uint prefix_length,
     {
       /* Read the next record in the same range with prefix after cur_prefix. */
       assert(cur_prefix != NULL);
+      file->set_end_range(NULL, handler::RANGE_SCAN_ASC);
       result= file->ha_index_read_map(record, cur_prefix, keypart_map,
                                       HA_READ_AFTER_KEY);
       if (result || last_range->max_keypart_map == 0)

